%title "KBRESET - Reset keyboard shift status"
%pagesize 78,132

; Title		: KBRESET
; Version	: 1.1
; Date		: 04 nov 1992
; Author	: J.R. Ferguson, Amsterdam, The Netherlands
; E-mail	: j.r.ferguson@iname.com
; Language	: Intel 8068/8088 assembler
; O.S.		: MS-DOS v3.2
; Assembler	: Borland Turbo Assembler v1.0, Ideal mode
; Usage		: KBRESET
; Function	: Reset Keyboard Status 
;		  ScrollLock, NumLock, CapsLock, Insert OFF

		ideal

;----------------------------------------------------------------------
; DECLARATIONS
;----------------------------------------------------------------------

KbStaSeg	=	0040h
KbStaOfs	=	0017h

KbInsert	=	80h
KbCapsLock	=	40h
KbNumLock	=	20h
KbScrollLock	=	10h

KbNeutral	= not (KbInsert or KbCapsLock or KbNumLock or KbScrollLock)


;----------------------------------------------------------------------
; CODE
;----------------------------------------------------------------------

segment		cseg	byte
		assume	cs:cseg, ds:cseg, ss: cseg
		org	0100h

proc		Main	far

		mov	ax,cs			;init DS register
		mov	ds,ax

		mov	ax,KbStaSeg		;reset keyboard shift status
		mov	es,ax
		mov	di,KbStaOfs
		mov	al,KbNeutral
		and	[es:di],al

		mov	dx,offset MsgConfirm	;display message
		mov	ah,09h
		int	21h

		mov	ax,4c00h		;exit returncode 0
		int	21h

endp		Main


;----------------------------------------------------------------------
; DATA
;----------------------------------------------------------------------

MsgConfirm	db	'Keyboard shift status reset$'

ends		cseg


		end	Main
